cheapskate-0.1.1.2: Experimental markdown processor.

Safe Haskell | Safe-Inferred
Language | Haskell2010

Cheapskate.Types

Synopsis

- data Doc = Doc Options Blocks
- data Block
  - = Para Inlines
  - | Header Int Inlines
  - | Blockquote Blocks
  - | List Bool ListType [Blocks]
  - | CodeBlock CodeAttr Text
  - | HtmlBlock Text
  - | HRule
- data CodeAttr = CodeAttr {
  - codeLang :: Text
  - codeInfo :: Text
  }
- data ListType
  - = Bullet Char
  - | Numbered NumWrapper Int
- data NumWrapper
  - = PeriodFollowing
  - | ParenFollowing
- data HtmlTagType
  - = Opening Text
  - | Closing Text
  - | SelfClosing Text
- type Blocks = Seq Block
- data Inline
  - = Str Text
  - | Space
  - | SoftBreak
  - | LineBreak
  - | Emph Inlines
  - | Strong Inlines
  - | Code Text
  - | Link Inlines Text Text
  - | Image Inlines Text Text
  - | Entity Text
  - | RawHtml Text
- type Inlines = Seq Inline
- type ReferenceMap = Map Text (Text, Text)
- data Options = Options {
  - sanitize :: Bool
  - allowRawHtml :: Bool
  - preserveHardBreaks :: Bool
  - debug :: Bool
  }

# Documentation

data Doc #

Structured representation of a document. The `Options` affect how the document is rendered by `toHtml`.

Constructors

Doc Options Blocks |

#### Instances

Instances details

Data Doc # |

Instance details

Defined in Cheapskate.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Doc -> c Doc #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Doc #

toConstr :: Doc -> Constr #

dataTypeOf :: Doc -> DataType #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Doc) #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Doc) #

gmapT :: (forall b. Data b => b -> b) -> Doc -> Doc #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Doc -> r #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Doc -> r #

gmapQ :: (forall d. Data d => d -> u) -> Doc -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Doc -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Doc -> m Doc #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Doc -> m Doc #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Doc -> m Doc #

Generic Doc # |

Instance details

Defined in Cheapskate.Types

Associated Types

type Rep Doc |

Instance details

Defined in Cheapskate.Types

type Rep Doc = D1 ('MetaData "Doc" "Cheapskate.Types" "cheapskate-0.1.1.2-IO4kiCt3pOH5W4CO8q0fi8" 'False) (C1 ('MetaCons "Doc" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Options) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Blocks)))

Methods

from :: Doc -> Rep Doc x #

to :: Rep Doc x -> Doc #

Show Doc # |
Instance details Defined in Cheapskate.Types Methods showsPrec :: Int -> Doc -> ShowS # show :: Doc -> String # showList :: [Doc] -> ShowS #
ToMarkup Doc # |
Instance details Defined in Cheapskate Methods toMarkup :: Doc -> Markup # preEscapedToMarkup :: Doc -> Markup #
NFData Doc # |
Instance details Defined in Cheapskate.Types Methods rnf :: Doc -> () #
type Rep Doc # |

Instance details

Defined in Cheapskate.Types

type Rep Doc = D1 ('MetaData "Doc" "Cheapskate.Types" "cheapskate-0.1.1.2-IO4kiCt3pOH5W4CO8q0fi8" 'False) (C1 ('MetaCons "Doc" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Options) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Blocks)))

data Block #

Block-level elements.

Constructors

Para Inlines |
Header Int Inlines |
Blockquote Blocks |
List Bool ListType [Blocks] |
CodeBlock CodeAttr Text |
HtmlBlock Text |
HRule |

#### Instances

Instances details

Data Block # |

Instance details

Defined in Cheapskate.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Block -> c Block #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Block #

toConstr :: Block -> Constr #

dataTypeOf :: Block -> DataType #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Block) #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Block) #

gmapT :: (forall b. Data b => b -> b) -> Block -> Block #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Block -> r #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Block -> r #

gmapQ :: (forall d. Data d => d -> u) -> Block -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Block -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Block -> m Block #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Block -> m Block #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Block -> m Block #

Generic Block # |

Instance details

Defined in Cheapskate.Types

Associated Types

type Rep Block |

Instance details

Defined in Cheapskate.Types

type Rep Block = D1 ('MetaData "Block" "Cheapskate.Types" "cheapskate-0.1.1.2-IO4kiCt3pOH5W4CO8q0fi8" 'False) ((C1 ('MetaCons "Para" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Inlines)) :+: (C1 ('MetaCons "Header" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Int) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Inlines)) :+: C1 ('MetaCons "Blockquote" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Blocks)))) :+: ((C1 ('MetaCons "List" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool) :*: (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 ListType) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [Blocks]))) :+: C1 ('MetaCons "CodeBlock" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 CodeAttr) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text))) :+: (C1 ('MetaCons "HtmlBlock" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)) :+: C1 ('MetaCons "HRule" 'PrefixI 'False) (U1 :: Type -> Type))))

Methods

from :: Block -> Rep Block x #

to :: Rep Block x -> Block #

Show Block # |
Instance details Defined in Cheapskate.Types Methods showsPrec :: Int -> Block -> ShowS # show :: Block -> String # showList :: [Block] -> ShowS #
NFData Block # |
Instance details Defined in Cheapskate.Types Methods rnf :: Block -> () #
type Rep Block # |

Instance details

Defined in Cheapskate.Types

type Rep Block = D1 ('MetaData "Block" "Cheapskate.Types" "cheapskate-0.1.1.2-IO4kiCt3pOH5W4CO8q0fi8" 'False) ((C1 ('MetaCons "Para" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Inlines)) :+: (C1 ('MetaCons "Header" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Int) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Inlines)) :+: C1 ('MetaCons "Blockquote" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Blocks)))) :+: ((C1 ('MetaCons "List" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool) :*: (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 ListType) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [Blocks]))) :+: C1 ('MetaCons "CodeBlock" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 CodeAttr) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text))) :+: (C1 ('MetaCons "HtmlBlock" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)) :+: C1 ('MetaCons "HRule" 'PrefixI 'False) (U1 :: Type -> Type))))

data CodeAttr #

Attributes for fenced code blocks. `codeLang` is the first word of the attribute line, `codeInfo` is the rest.

Constructors

CodeAttr |

Fields

- codeLang :: Text
- codeInfo :: Text

#### Instances

Instances details

Data CodeAttr # |

Instance details

Defined in Cheapskate.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> CodeAttr -> c CodeAttr #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c CodeAttr #

toConstr :: CodeAttr -> Constr #

dataTypeOf :: CodeAttr -> DataType #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c CodeAttr) #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c CodeAttr) #

gmapT :: (forall b. Data b => b -> b) -> CodeAttr -> CodeAttr #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> CodeAttr -> r #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> CodeAttr -> r #

gmapQ :: (forall d. Data d => d -> u) -> CodeAttr -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> CodeAttr -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> CodeAttr -> m CodeAttr #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> CodeAttr -> m CodeAttr #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> CodeAttr -> m CodeAttr #

Generic CodeAttr # |

Instance details

Defined in Cheapskate.Types

Associated Types

type Rep CodeAttr |

Instance details

Defined in Cheapskate.Types

type Rep CodeAttr = D1 ('MetaData "CodeAttr" "Cheapskate.Types" "cheapskate-0.1.1.2-IO4kiCt3pOH5W4CO8q0fi8" 'False) (C1 ('MetaCons "CodeAttr" 'PrefixI 'True) (S1 ('MetaSel ('Just "codeLang") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: S1 ('MetaSel ('Just "codeInfo") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)))

Methods

from :: CodeAttr -> Rep CodeAttr x #

to :: Rep CodeAttr x -> CodeAttr #

Show CodeAttr # |
Instance details Defined in Cheapskate.Types Methods showsPrec :: Int -> CodeAttr -> ShowS # show :: CodeAttr -> String # showList :: [CodeAttr] -> ShowS #
NFData CodeAttr # |
Instance details Defined in Cheapskate.Types Methods rnf :: CodeAttr -> () #
type Rep CodeAttr # |

Instance details

Defined in Cheapskate.Types

type Rep CodeAttr = D1 ('MetaData "CodeAttr" "Cheapskate.Types" "cheapskate-0.1.1.2-IO4kiCt3pOH5W4CO8q0fi8" 'False) (C1 ('MetaCons "CodeAttr" 'PrefixI 'True) (S1 ('MetaSel ('Just "codeLang") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: S1 ('MetaSel ('Just "codeInfo") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)))

data ListType #

Constructors

Bullet Char |
Numbered NumWrapper Int |

#### Instances

Instances details

Data ListType # |

Instance details

Defined in Cheapskate.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> ListType -> c ListType #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c ListType #

toConstr :: ListType -> Constr #

dataTypeOf :: ListType -> DataType #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c ListType) #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c ListType) #

gmapT :: (forall b. Data b => b -> b) -> ListType -> ListType #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> ListType -> r #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> ListType -> r #

gmapQ :: (forall d. Data d => d -> u) -> ListType -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> ListType -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> ListType -> m ListType #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> ListType -> m ListType #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> ListType -> m ListType #

Generic ListType # |

Instance details

Defined in Cheapskate.Types

Associated Types

type Rep ListType |

Instance details

Defined in Cheapskate.Types

type Rep ListType = D1 ('MetaData "ListType" "Cheapskate.Types" "cheapskate-0.1.1.2-IO4kiCt3pOH5W4CO8q0fi8" 'False) (C1 ('MetaCons "Bullet" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Char)) :+: C1 ('MetaCons "Numbered" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 NumWrapper) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Int)))

Methods

from :: ListType -> Rep ListType x #

to :: Rep ListType x -> ListType #

Show ListType # |
Instance details Defined in Cheapskate.Types Methods showsPrec :: Int -> ListType -> ShowS # show :: ListType -> String # showList :: [ListType] -> ShowS #
NFData ListType # |
Instance details Defined in Cheapskate.Types Methods rnf :: ListType -> () #
Eq ListType # |
Instance details Defined in Cheapskate.Types Methods (==) :: ListType -> ListType -> Bool # (/=) :: ListType -> ListType -> Bool #
type Rep ListType # |

Instance details

Defined in Cheapskate.Types

type Rep ListType = D1 ('MetaData "ListType" "Cheapskate.Types" "cheapskate-0.1.1.2-IO4kiCt3pOH5W4CO8q0fi8" 'False) (C1 ('MetaCons "Bullet" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Char)) :+: C1 ('MetaCons "Numbered" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 NumWrapper) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Int)))

data NumWrapper #

Constructors

PeriodFollowing |
ParenFollowing |

#### Instances

Instances details

Data NumWrapper # |

Instance details

Defined in Cheapskate.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> NumWrapper -> c NumWrapper #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c NumWrapper #

toConstr :: NumWrapper -> Constr #

dataTypeOf :: NumWrapper -> DataType #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c NumWrapper) #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c NumWrapper) #

gmapT :: (forall b. Data b => b -> b) -> NumWrapper -> NumWrapper #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> NumWrapper -> r #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> NumWrapper -> r #

gmapQ :: (forall d. Data d => d -> u) -> NumWrapper -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> NumWrapper -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> NumWrapper -> m NumWrapper #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> NumWrapper -> m NumWrapper #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> NumWrapper -> m NumWrapper #

Generic NumWrapper # |

Instance details

Defined in Cheapskate.Types

Associated Types

type Rep NumWrapper |
Instance details Defined in Cheapskate.Types type Rep NumWrapper = D1 ('MetaData "NumWrapper" "Cheapskate.Types" "cheapskate-0.1.1.2-IO4kiCt3pOH5W4CO8q0fi8" 'False) (C1 ('MetaCons "PeriodFollowing" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "ParenFollowing" 'PrefixI 'False) (U1 :: Type -> Type))

Methods

from :: NumWrapper -> Rep NumWrapper x #

to :: Rep NumWrapper x -> NumWrapper #

Show NumWrapper # |
Instance details Defined in Cheapskate.Types Methods showsPrec :: Int -> NumWrapper -> ShowS # show :: NumWrapper -> String # showList :: [NumWrapper] -> ShowS #
NFData NumWrapper # |
Instance details Defined in Cheapskate.Types Methods rnf :: NumWrapper -> () #
Eq NumWrapper # |
Instance details Defined in Cheapskate.Types Methods (==) :: NumWrapper -> NumWrapper -> Bool # (/=) :: NumWrapper -> NumWrapper -> Bool #
type Rep NumWrapper # |
Instance details Defined in Cheapskate.Types type Rep NumWrapper = D1 ('MetaData "NumWrapper" "Cheapskate.Types" "cheapskate-0.1.1.2-IO4kiCt3pOH5W4CO8q0fi8" 'False) (C1 ('MetaCons "PeriodFollowing" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "ParenFollowing" 'PrefixI 'False) (U1 :: Type -> Type))

data HtmlTagType #

Simple representation of HTML tag.

Constructors

Opening Text |
Closing Text |
SelfClosing Text |

#### Instances

Instances details

Data HtmlTagType # |

Instance details

Defined in Cheapskate.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> HtmlTagType -> c HtmlTagType #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c HtmlTagType #

toConstr :: HtmlTagType -> Constr #

dataTypeOf :: HtmlTagType -> DataType #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c HtmlTagType) #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c HtmlTagType) #

gmapT :: (forall b. Data b => b -> b) -> HtmlTagType -> HtmlTagType #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> HtmlTagType -> r #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> HtmlTagType -> r #

gmapQ :: (forall d. Data d => d -> u) -> HtmlTagType -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> HtmlTagType -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> HtmlTagType -> m HtmlTagType #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> HtmlTagType -> m HtmlTagType #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> HtmlTagType -> m HtmlTagType #

Generic HtmlTagType # |

Instance details

Defined in Cheapskate.Types

Associated Types

type Rep HtmlTagType |

Instance details

Defined in Cheapskate.Types

type Rep HtmlTagType = D1 ('MetaData "HtmlTagType" "Cheapskate.Types" "cheapskate-0.1.1.2-IO4kiCt3pOH5W4CO8q0fi8" 'False) (C1 ('MetaCons "Opening" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)) :+: (C1 ('MetaCons "Closing" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)) :+: C1 ('MetaCons "SelfClosing" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text))))

Methods

from :: HtmlTagType -> Rep HtmlTagType x #

to :: Rep HtmlTagType x -> HtmlTagType #

Show HtmlTagType # |
Instance details Defined in Cheapskate.Types Methods showsPrec :: Int -> HtmlTagType -> ShowS # show :: HtmlTagType -> String # showList :: [HtmlTagType] -> ShowS #
NFData HtmlTagType # |
Instance details Defined in Cheapskate.Types Methods rnf :: HtmlTagType -> () #
type Rep HtmlTagType # |

Instance details

Defined in Cheapskate.Types

type Rep HtmlTagType = D1 ('MetaData "HtmlTagType" "Cheapskate.Types" "cheapskate-0.1.1.2-IO4kiCt3pOH5W4CO8q0fi8" 'False) (C1 ('MetaCons "Opening" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)) :+: (C1 ('MetaCons "Closing" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)) :+: C1 ('MetaCons "SelfClosing" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text))))

type Blocks = Seq Block #

data Inline #

Inline elements.

Constructors

Str Text |
Space |
SoftBreak |
LineBreak |
Emph Inlines |
Strong Inlines |
Code Text |
Link Inlines Text Text |
Image Inlines Text Text |
Entity Text |
RawHtml Text |

#### Instances

Instances details

Data Inline # |

Instance details

Defined in Cheapskate.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Inline -> c Inline #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Inline #

toConstr :: Inline -> Constr #

dataTypeOf :: Inline -> DataType #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Inline) #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Inline) #

gmapT :: (forall b. Data b => b -> b) -> Inline -> Inline #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Inline -> r #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Inline -> r #

gmapQ :: (forall d. Data d => d -> u) -> Inline -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Inline -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Inline -> m Inline #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Inline -> m Inline #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Inline -> m Inline #

Generic Inline # |

Instance details

Defined in Cheapskate.Types

Associated Types

type Rep Inline |

Instance details

Defined in Cheapskate.Types

type Rep Inline = D1 ('MetaData "Inline" "Cheapskate.Types" "cheapskate-0.1.1.2-IO4kiCt3pOH5W4CO8q0fi8" 'False) (((C1 ('MetaCons "Str" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)) :+: C1 ('MetaCons "Space" 'PrefixI 'False) (U1 :: Type -> Type)) :+: (C1 ('MetaCons "SoftBreak" 'PrefixI 'False) (U1 :: Type -> Type) :+: (C1 ('MetaCons "LineBreak" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "Emph" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Inlines))))) :+: ((C1 ('MetaCons "Strong" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Inlines)) :+: (C1 ('MetaCons "Code" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)) :+: C1 ('MetaCons "Link" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Inlines) :*: (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text))))) :+: (C1 ('MetaCons "Image" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Inlines) :*: (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text))) :+: (C1 ('MetaCons "Entity" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)) :+: C1 ('MetaCons "RawHtml" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text))))))

Methods

from :: Inline -> Rep Inline x #

to :: Rep Inline x -> Inline #

Show Inline # |
Instance details Defined in Cheapskate.Types Methods showsPrec :: Int -> Inline -> ShowS # show :: Inline -> String # showList :: [Inline] -> ShowS #
NFData Inline # |
Instance details Defined in Cheapskate.Types Methods rnf :: Inline -> () #
type Rep Inline # |

Instance details

Defined in Cheapskate.Types

type Rep Inline = D1 ('MetaData "Inline" "Cheapskate.Types" "cheapskate-0.1.1.2-IO4kiCt3pOH5W4CO8q0fi8" 'False) (((C1 ('MetaCons "Str" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)) :+: C1 ('MetaCons "Space" 'PrefixI 'False) (U1 :: Type -> Type)) :+: (C1 ('MetaCons "SoftBreak" 'PrefixI 'False) (U1 :: Type -> Type) :+: (C1 ('MetaCons "LineBreak" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "Emph" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Inlines))))) :+: ((C1 ('MetaCons "Strong" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Inlines)) :+: (C1 ('MetaCons "Code" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)) :+: C1 ('MetaCons "Link" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Inlines) :*: (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text))))) :+: (C1 ('MetaCons "Image" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Inlines) :*: (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text))) :+: (C1 ('MetaCons "Entity" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)) :+: C1 ('MetaCons "RawHtml" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text))))))

type Inlines = Seq Inline #

type ReferenceMap = Map Text (Text, Text) #

data Options #

Rendering and parsing options.

Constructors

Options |

Fields

- sanitize :: Bool

  Sanitize raw HTML, link/image attributes

- allowRawHtml :: Bool

  Allow raw HTML (if false it gets escaped)

- preserveHardBreaks :: Bool

  Preserve hard line breaks in the source

- debug :: Bool

  Print container structure for debugging

#### Instances

Instances details

Data Options # |

Instance details

Defined in Cheapskate.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Options -> c Options #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Options #

toConstr :: Options -> Constr #

dataTypeOf :: Options -> DataType #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Options) #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Options) #

gmapT :: (forall b. Data b => b -> b) -> Options -> Options #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Options -> r #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Options -> r #

gmapQ :: (forall d. Data d => d -> u) -> Options -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Options -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Options -> m Options #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Options -> m Options #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Options -> m Options #

Generic Options # |

Instance details

Defined in Cheapskate.Types

Associated Types

type Rep Options |

Instance details

Defined in Cheapskate.Types

type Rep Options = D1 ('MetaData "Options" "Cheapskate.Types" "cheapskate-0.1.1.2-IO4kiCt3pOH5W4CO8q0fi8" 'False) (C1 ('MetaCons "Options" 'PrefixI 'True) ((S1 ('MetaSel ('Just "sanitize") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool) :*: S1 ('MetaSel ('Just "allowRawHtml") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool)) :*: (S1 ('MetaSel ('Just "preserveHardBreaks") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool) :*: S1 ('MetaSel ('Just "debug") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool))))

Methods

from :: Options -> Rep Options x #

to :: Rep Options x -> Options #

Show Options # |
Instance details Defined in Cheapskate.Types Methods showsPrec :: Int -> Options -> ShowS # show :: Options -> String # showList :: [Options] -> ShowS #
Default Options # |
Instance details Defined in Cheapskate.Types Methods def :: Options #
NFData Options # |
Instance details Defined in Cheapskate.Types Methods rnf :: Options -> () #
type Rep Options # |

Instance details

Defined in Cheapskate.Types

type Rep Options = D1 ('MetaData "Options" "Cheapskate.Types" "cheapskate-0.1.1.2-IO4kiCt3pOH5W4CO8q0fi8" 'False) (C1 ('MetaCons "Options" 'PrefixI 'True) ((S1 ('MetaSel ('Just "sanitize") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool) :*: S1 ('MetaSel ('Just "allowRawHtml") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool)) :*: (S1 ('MetaSel ('Just "preserveHardBreaks") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool) :*: S1 ('MetaSel ('Just "debug") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool))))